#if !defined(_MACHINE_ZS_H)

#include <machine/cons.h>

struct zschan {
	volatile u_char zc_ctrl;
	u_char zc_pad0;
	volatile u_char zc_data;
	u_char zs_pad1;
};

struct zschip {
	struct zschan zs_chan[2];
};
#define ZS_CHAN_A	1
#define ZS_CHAN_B	0

#define ZS_R0	0
#define ZS_R1	1
#define ZS_R2	2
#define ZS_R3	3
#define ZS_R4	4
#define ZS_R5	5
#define ZS_R6	6
#define ZS_R7	7
#define ZS_R8	8
#define ZS_R9	9
#define ZS_R10	10
#define ZS_R11	11
#define ZS_R12	12
#define ZS_R13	13
#define ZS_R14	14
#define ZS_R15	15

#define ZS9_HWRST	0xc0	/* hardware reset */
#define ZS9_RESET_A	0x80	/* reset channel A */
#define ZS9_RESET_B	0x40	/* reset channel B */
#define ZS9_NOVEC	0x02	/* no vector */
#define ZS9_MASTER_IE	0x08	/* master ienterrupt enable */

#define ZS4_EVENP	0x02	/* even parity */
#define ZS4_CLK_X1	0x00	/* clock divisor */
#define ZS4_CLK_X16	0x40
#define ZS4_CLK_X32	0x80
#define ZS4_CLK_X64	0xc0
#define ZS4_SB1		0x04	/* one stop bit */

#define ZS3_RX5		0x00	/* bits per receive char */
#define ZS3_RX7		0x40
#define ZS3_RX6		0x80
#define ZS3_RX8		0xc0
#define ZS3_RXEN	0x01

#define ZS5_TX5		0x00	/* bits per transmit char */
#define ZS5_TX7		0x20
#define ZS5_TX6		0x40
#define ZS5_TX8		0x60
#define ZS5_TXEN	0x08
#define ZS5_DTR		0x80

#define ZS10_NRZ	0x00	/* encoding */
#define ZS10_NRZI	0x20
#define ZS10_FM1	0x40
#define ZS10_FM0	0x60

#define ZS11_RX_BR	0x40
#define ZS11_TX_BR	0x10

#define ZS14_BRSRC_PCLK 0x02	/* BRG source is PCLK */
#define ZS14_BREN	0x01	/* enable BRG */

#define ZS0_RESET_EXTINT 0x10	/* reset external/status interrupts */
#define ZS0_RESET_ERRORS 0x30	/* reset errors */
#define ZS0_TX_RDY	0x04	/* transmit buffer empty */

#define ZS15_DCD_IE	0x08	/* enable DCD# pin interrupt */
#define ZS15_CTS_IE	0x20
#define ZS15_TXU_IE	0x40
#define ZS15_BRK_IE	0x80

#define ZS1_ALL_SENT	0x01	/* all chars out */
#define ZS1_EXTINT_EN	0x01	
#define ZS1_INTALL_RX	0x10

#define ZS_INCLK	4915200
#define BPS_TO_BRG(f, bps) ((((f) + (bps))/(2*(bps))) - 2)

#define ZS_READ(c, r)	((c)->zc_ctrl = (r), (c)->zc_ctrl)
#define ZS_WRITE(c, r, v) ((c)->zc_ctrl = (r), (c)->zc_ctrl = v)

extern void zscnprobe(struct consdev *);
extern void zscninit(struct consdev *);
extern void zscnputc(dev_t, int);

extern struct zschip *zs;

#endif /* ! _MACHINE_ZS_H */
