#include <sys/types.h>
#include <sys/systm.h>
#include <machine/cpu.h>
#include <machine/prom.h>
#include <machine/frame.h>

static struct cpu_info {
	unsigned manuf;
	unsigned impl;
	char *info;
} known_ultras[] = { {0x17, 0x10, "UltraSparc-I"},
		     {0x17, 0x11, "UltraSparc-II"},
		     {0, 0, "(unknown)"}};

void
ident_cpu()
{
	unsigned long ver;
	int i;

	__asm__ __volatile__("rdpr	%%ver, %0" : "=r" (ver));
	for (i = 0; known_ultras[i].manuf != 0; i++)
		if (known_ultras[i].manuf == VER_MANUF(ver) &&
		    known_ultras[i].impl == VER_IMPL(ver))
			break;
	printf("CPU: %s (manuf=0x%lx, impl=0x%lx), MAXTL=%ld, MAXWIN = %ld\n",
	       known_ultras[i].info, VER_MANUF(ver), VER_IMPL(ver),
	       VER_MAXTL(ver), VER_MAXWIN(ver));
}
