#define _LOCORE 1

#include <machine/cpu.h>
#include <machine/param.h>
#include <machine/pmap.h>
#include <machine/asi.h>
#include <machine/frame.h>

	.text
	.globl _start, prom_cmd, back_to_prom

	! We are at vaddr 0x0000000000004000
	! obpvec is passed in %o1, CIF handler is passed in %o4,
	! PROMs stack pointer in %sp
	! All code must be PIC until we relocate ourselves.
_start:
	wrpr	PSTATE_KERN, %pstate
	wr	%g0, %g0, %fprs

	! invalidate all mappings between KERNBASE and KERNBASE+4M
	setx	TAG_VAMASK, %l5, %g1
	setx	KERNBASE, %l5, %l1
	and	%l1, %g1, %l1
	setx	KERNBASE+0x400000, %l5, %l2
	and	%l2, %g1, %l2

	mov	%g0, %l0
1:	ldxa	[%l0] ASI_ITLB_TAG_READ_REG, %l3
	or	%l3, 0, %l3
	and	%l3, %g1, %l4
	cmp	%l1, %l4
	bgu	2f
	cmp	%l2, %l4
	blu	2f
	nop
	stxa	%g0, [%l3] ASI_IMMU_DEMAP
2:	cmp	%l0, (63<<3)
	bleu,pt	%xcc, 1b
	add	%l0, 8, %l0

	mov	%g0, %l0
1:	ldxa	[%l0] ASI_DTLB_TAG_READ_REG, %l3
	or	%l3, 0, %l3
	and	%l3, %g1, %l4
	cmp	%l1, %l4
	bgu	2f
	cmp	%l2, %l4
	blu	2f
	nop
	stxa	%g0, [%l3] ASI_DMMU_DEMAP
2:	cmp	%l0, (63<<3)
	bleu,pt	%xcc, 1b
	add	%l0, 8, %l0

	flush	%l3
	membar	#Sync

	! XXX lock CIF handler into iTLB and dTLB
	! put 4MB entry for kernel into dTLB and iTLB.
	and	%l1, %g1, %l1
	mov	63<<3, %g1
	setx	TTE_KERN|TTE_SZ4M|TTE_LOCK, %l5, %l2
	mov	TAG_ACCESS_REG, %g2
	stxa	%l1, [%g2] ASI_DMMU
	stxa	%l2, [%g1] ASI_DTLB_DATA_ACCESS_REG
	stxa	%l1, [%g2] ASI_IMMU
	stxa	%l2, [%g1] ASI_ITLB_DATA_ACCESS_REG
	setx	relocated, %l5, %l1
	flush	%l1
	membar	#Sync
	jmpl	%l1, %g0
	nop
	nop

	! we are relocated into 0x0000000000404xxx
relocated:
	! XXX %g4 and %g6 are special regs
	clr	%g4

	setx	prom_cif_handler, %l5, %l1	! CIF Handler
	stx	%o4, [%l1]
	setx	prom_cif_sp, %l5, %l1		! CIF Stack
	stx	%sp, [%l1]

	setx	_kern_stack, %l5, %l1		! Initialize kernel stack
	sub	%l1, REGWIN_SZ + BIAS, %sp
	mov	%g0, %fp

	wrpr	%g0, 0, %wstate
	wrpr	%g0, 0, %tl

	call	prom_init
	nop

	call	init_sparc64
	nop

	set	bye, %o0
	call	printf
	 nop

back_to_prom:
	wrpr	%g0, 0, %tl		! make the PROM happy
	set	prom_tba, %l0		! restore tba for PROM
	ldx	[%l0], %l0
	wrpr	%l0, %tba
	call	prom_exit
	nop

prom_cmd:
	setx	prom_cif_sp, %l5, %o1
	ldx	[%o1], %o1
	save	%o1, -0xc0, %sp
	setx	prom_cif_handler, %l5, %l2
	ldx	[%l2], %l2
	mov	%g4, %l0		! %g4 and %g6 are special registers
	mov	%g6, %l1
	call	%l2
	mov	%i0, %o0
	mov     %l0, %g4
	ret
	restore	%l1, 0, %g6

	.data
	.globl	prom_tba
	.align	8
bye:	.asciz	"bye\n"
	.align	8
prom_cif_sp:
	.xword	0
prom_cif_handler:
	.xword	0
prom_tba:
	.xword	0

	.text
_elocore:
	.skip	_start + 0x10000 - _elocore
_kern_stack:
	.xword	0
	.globl	trap_stack
	.align	32
	.fill	1024, 8, 0
trap_stack:
	.xword	0
