#include <machine/prom.h>
#include <machine/cpu.h>
#include <machine/frame.h>
#include <sys/systm.h>
#include <machine/asi.h>
#include <machine/pmap.h>

unsigned long trap_state[3*20] = {5, 5};
unsigned long ticks = 0;

void
bad_trap()
{
	printf("whee: primary context=0x%lx\n", get_primary_context());
}

void
do_timer()
{
	register unsigned long tick_cmpr;

	ticks ++;
	__asm__ __volatile__("
		rd %%tick_cmpr, %0
		add %0, %1, %0
		wr %0, 0, %%tick_cmpr
	" : "=&r"(tick_cmpr) : "r"(142857143/100));
}

void
barf_trap_data(int howmany)
{
	unsigned i;

	printf("ticks : 0x%lx\n", ticks);
	printf("trap state :\n");
	for (i = 0; i < howmany; i++)
		printf("%d: 0x%016lx\n", i, trap_state[i]);
	printf("zs_buf :\n");
}
